#ifndef __TIME_H__
#define __TIME_H__

#define TIMESPEC2NANOSEC(t)     ((t)->tv_sec * 1000000000 + (t)->tv_nsec)
#define TIMESPEC2USEC(t)     ((t)->tv_sec * 1000000 + (t)->tv_nsec / 1000)
#define NULL_TIMESPEC(t)        ((t)->tv_sec = (t)->tv_nsec = 0)
#define ADDNANO2TIMESPEC(n, t)  ((t)->tv_nsec += (n), \
		(t)->tv_sec += (t)->tv_nsec / 1000000000, \
		(t)->tv_nsec %= 1000000000)

#define SUBTIMESPEC(s1, s2, d)                               \
	((d)->tv_nsec = ((s1)->tv_nsec >= (s2)->tv_nsec) ?   \
	 (((d)->tv_sec = (s1)->tv_sec - (s2)->tv_sec),       \
	  (s1)->tv_nsec - (s2)->tv_nsec)                     \
	 :                                                   \
	 (((d)->tv_sec = (s1)->tv_sec - (s2)->tv_sec - 1),   \
	  (1000000000 + (s1)->tv_nsec - (s2)->tv_nsec)))

/*
 * ...and these not!
 */

extern __inline__ void ADDTIMESPEC(const struct timespec *s1,
                                   const struct timespec *s2,
                                   struct timespec *d)
{
  d->tv_sec  = s1->tv_sec + s2->tv_sec;
  d->tv_nsec = s1->tv_nsec + s2->tv_nsec;

  if (d->tv_nsec < 0) {
    d->tv_sec--;
    d->tv_nsec += 1000000000;
  } else if (d->tv_nsec >= 1000000000) {
    d->tv_sec++;
    d->tv_nsec -= 1000000000;
  }
}


#define ADDUSEC2TIMESPEC(m, t)  ((t)->tv_nsec += (m%1000000)*1000,        \
		(t)->tv_sec += ((t)->tv_nsec / 1000000000) + (m/1000000), \
		(t)->tv_nsec %= 1000000000)

#define TIMESPEC_A_LT_B(a,b)                                            \
        (                                                               \
        ((a)->tv_sec <  (b)->tv_sec) ||                                 \
        ((a)->tv_sec == (b)->tv_sec && (a)->tv_nsec < (b)->tv_nsec)    \
        )

#define TIMESPEC_A_GT_B(a,b)                                            \
        (                                                               \
        ((a)->tv_sec >  (b)->tv_sec) ||                                 \
        ((a)->tv_sec == (b)->tv_sec && (a)->tv_nsec > (b)->tv_nsec)    \
        )

#define TIMESPEC_A_EQ_B(a,b)                                            \
        ((a)->tv_sec == (b)->tv_sec && (a)->tv_nsec == (b)->tv_nsec)

#define TIMESPEC_A_NEQ_B(a,b)                                            \
        ((a)->tv_sec != (b)->tv_sec || (a)->tv_nsec != (b)->tv_nsec)

#define TIMESPEC_ASSIGN(t1,t2) \
        ((t1)->tv_sec = (t2)->tv_sec, (t1)->tv_nsec = (t2)->tv_nsec)

#endif
