#ifndef __LPARSER_H__
#define __LPARSER_H__

#include "common/lconst.h"

struct loader_task {
  
  char name[20];
  int number;
  int group;
  int server;
  int local_scheduler;
  int task_type;

  int act_type;
  struct timespec act_par_1;
  struct timespec act_par_2;
  struct timespec act_par_3;
  int exec_type;
  struct timespec exec_par_1;
  struct timespec exec_par_2;
  
  struct timespec deadline;
  struct timespec wcet;
 
  int act_number;
  struct timespec *act;
  struct timespec *exec;

  int crit_type;
  int resource;
  struct timespec crit_par;
 
  struct loader_task *next;

};

struct loader_contract {

  int number;
  struct timespec cmin;
  struct timespec tmax;
  struct timespec cmax;
  struct timespec tmin;
  int workload;
  struct timespec  deadline;
  int local_scheduler;

  struct loader_contract *next;

};

int line_parser_contract(char **buf, int line_num, struct timespec *total_time, struct loader_contract **last);

int line_parser_task(char **buf, int line_num, struct loader_task **last);

#endif

