//=======================================================================
//       FFFFFFIII   RRRRR      SSTTTTTTT
//      FF         IIR   RR    SS
//     FF           IR        SS
//    FFFFFF         RRRR    SSSSST      
//   FF       FI       RRR  SS
//  FF         II     RRR  SS
// FF           IIIIIR    RS
//
// Basic FSF(FIRST Scheduling Framework) configuration parameters
// S.Ha.R.K. Implementation
//=======================================================================

///////////////////////////////////////////////////////////////////
// Definitions required to configure the fsf scheduling algorithms.

#include <sys/boolean.h>

#ifndef _FSF_CONFIGURATION_PARAMETERS_H_
#define _FSF_CONFIGURATION_PARAMETERS_H_


// This symbol specifies whether the scheduler will make a
// schedulability of the requested contract or not
#define FSF_ADMISSION_TEST_IS_ENABLED        false


// Tune these values for optimizing the amount of memory used by
// the implementation

// Maximum number of accepted contracts (servers)
#define FSF_MAX_N_SERVERS                    20

// Maximum number of threads that may be scheduled by the framework
#define FSF_MAX_N_THREADS                    20

// Maximum number of critical sections that can be stored in a 
// contract parameters object
#define FSF_MAX_N_CRITICAL_SECTIONS          20

// Maximum number of utilization values (pairs of budget and period) 
// that can be stored in a contract parameters object
#define FSF_MAX_N_UTILIZATION_VALUES         20

#define FSF_MAX_N_BIND_THREAD	             1

#endif
